//#define UNICODE
#include <windows.h>
#include <iostream>
using namespace std;

int ReadConsoleTimeOutW(WCHAR* pBuffer,long ccBuffer,DWORD dwTimeOut);
bool IsValidChar(WCHAR chr);
int StrCatW(WCHAR* lpBuffer,int ccBuffer,WCHAR** papwsz);
int StrCopyNW(WCHAR* lpBuffer,int ccBuffer,WCHAR* lpSrc,int nChar);
WCHAR* dw2BaseXW(unsigned int num, int base ,WCHAR* pszBuffer);
int wszlen(WCHAR* pwsz);

int main()
{
    WCHAR bufferW[301];
    char  bufferA[301];
    int nChar;

    cout << "5 Zeichen maximal, 10 Sekunden: ";
    nChar = ReadConsoleTimeOutW(&bufferW[0],6,10000);
    WideCharToMultiByte(CP_OEMCP,0,&bufferW[0],6,&bufferA[0],6,0,0);
    cout << "Eingabe: "<<"<"<<bufferA<<">"<<"\nnChar: "<<nChar<<"\n";
    cout << "300 Zeichen maximal, 1 Minute: ";
    nChar = ReadConsoleTimeOutW(&bufferW[0],301,60000);
    WideCharToMultiByte(CP_OEMCP,0,&bufferW[0],301,&bufferA[0],301,0,0);
    cout << "\nEingabe: "<<"<"<<bufferA<<">"<<"\n\nnChar: "<<nChar<<"\n";

    cout << "...";
    getchar();
}

//
// in:
//      pBuffer: pointer to buffer (UNICODE)
//      ccBuffer: size of buffer in characters (including termination-zero)
//      dwTimeOut: timeout-value in milliseconds
// out:
//       number of char. in buffer (or 0)
//
int ReadConsoleTimeOutW(WCHAR* pBuffer,long ccBuffer,DWORD dwTimeOut)
{
    HANDLE hIn,hOut,handles[2];
    DWORD ticks,ct,delta,nEvent,dwResult,szs1;
	int iBuff=0,max=0,dwSize,cntr=dwTimeOut/1000;
    WCHAR *pBuf,*pwsz[4];
	WCHAR buf[11];
    INPUT_RECORD InRec[10];
    CONSOLE_SCREEN_BUFFER_INFO csbi;
    COORD home,end,tmp,cnt;
	LARGE_INTEGER li;
	
    pBuf =(WCHAR*)GlobalAlloc(GPTR,ccBuffer*2);
    hIn=GetStdHandle(STD_INPUT_HANDLE);
    hOut=GetStdHandle(STD_OUTPUT_HANDLE);
    FlushConsoleInputBuffer(hIn);
    ticks=GetTickCount();

	GetConsoleScreenBufferInfo(hOut,&csbi);
	cnt=csbi.dwCursorPosition;
	szs1=wszlen(dw2BaseXW(cntr,10,&buf[0]));
	WriteConsoleW(hOut,dw2BaseXW(cntr,10,&buf[0]),szs1,0,0);
	csbi.dwCursorPosition.X = csbi.dwCursorPosition.X+(short)szs1+1;
	SetConsoleCursorPosition(hOut,csbi.dwCursorPosition);    
	home=csbi.dwCursorPosition;
    end=csbi.dwCursorPosition;

	handles[0] = CreateWaitableTimer(0,0,0);
	li.QuadPart=0;
	SetWaitableTimer(handles[0],&li,1000,0,0,1);
	handles[1] = hIn;

    pBuffer[0]=0;
    while(TRUE)
    {
		if((dwResult=WaitForMultipleObjects(2,&handles[0],0,dwTimeOut))==WAIT_TIMEOUT)
		{
			GetConsoleScreenBufferInfo(hOut,&csbi);
			SetConsoleCursorPosition(hOut,cnt);  
			WriteConsoleW(hOut,dw2BaseXW(cntr,10,&buf[0]),szs1,0,0);
			SetConsoleCursorPosition(hOut,csbi.dwCursorPosition);   
			break; 
		}

        if((delta=((ct=GetTickCount())-ticks)) > dwTimeOut)
            break;
        dwTimeOut = dwTimeOut - delta;
        ticks = ct;

		if(dwResult==WAIT_OBJECT_0)
		{	
			GetConsoleScreenBufferInfo(hOut,&csbi);
			SetConsoleCursorPosition(hOut,cnt);  
			WriteConsoleW(hOut,dw2BaseXW(cntr,10,&buf[0]),szs1,0,0);
			SetConsoleCursorPosition(hOut,csbi.dwCursorPosition);    
			cntr--;
			continue;	
		}

        ReadConsoleInputW(hIn,&InRec[0],10,&(nEvent=0));
        for(int i=0;nEvent!=0;i++,nEvent--)
        {
            if(InRec[i].EventType == KEY_EVENT)
            {
                if(InRec[i].Event.KeyEvent.bKeyDown)
                {
                    GetConsoleScreenBufferInfo(hOut,&csbi);
                    switch (InRec[i].Event.KeyEvent.wVirtualKeyCode)
                    {
                    case VK_RETURN:
                        goto _ret_;
                    case VK_ESCAPE:
                        goto _ret_;
                    case VK_BACK:
                        if(iBuff > 0)
                        {
                            if(csbi.dwCursorPosition.X > 0)
                            {
                                csbi.dwCursorPosition.X--;
                            }
                            else
                            {
                                if(csbi.dwCursorPosition.Y > 0)
                                {
                                    csbi.dwCursorPosition.Y--;
                                    csbi.dwCursorPosition.X=csbi.dwSize.X-1;
                                }
                            }
                            SetConsoleCursorPosition(hOut,csbi.dwCursorPosition);
                            iBuff--;
                        }
                        else{continue;}
                    case VK_DELETE:
                        if(iBuff < max)
                        {
                            pBuffer[iBuff]=0;
                            dwSize=StrCatW(&pBuffer[0],ccBuffer,(pwsz[0]=&pBuffer[0],pwsz[1]=&pBuffer[iBuff+1],pwsz[2]=0,(WCHAR**)&pwsz));
                            WriteConsoleW(hOut,&pBuffer[iBuff],dwSize-iBuff,0,0);
                            max--;

                            tmp=csbi.dwCursorPosition;
                            GetConsoleScreenBufferInfo(hOut,&csbi);
                            end=csbi.dwCursorPosition;
                            csbi.dwCursorPosition=tmp;
                            WriteConsoleW(hOut,L" ",1,0,0);
                        }else{continue;}
                        break;
                    case VK_HOME:
                        csbi.dwCursorPosition=home;
                        iBuff=0;
                        break;
                    case VK_END:
                        csbi.dwCursorPosition=end;
                        iBuff=max;
                        break;
                    case VK_LEFT:
                        if(iBuff > 0)
                        {
                            if(csbi.dwCursorPosition.X > 0)
                            {
                                csbi.dwCursorPosition.X--;
                            }
                            else
                            {
                                if(csbi.dwCursorPosition.Y > 0)
                                {
                                    csbi.dwCursorPosition.Y--;
                                    csbi.dwCursorPosition.X=csbi.dwSize.X-1;
                                }
                            }
                            iBuff--;
                        }else{continue;}
                        break;
                    case VK_RIGHT:
                        if(iBuff<max)
                        {
                            if(csbi.dwCursorPosition.X >= csbi.dwSize.X-1)
                            {
                                csbi.dwCursorPosition.X=0;
                                csbi.dwCursorPosition.Y++;
                            }
                            else
                            {
                                csbi.dwCursorPosition.X++;
                            }
                            iBuff++;
                        }else{continue;}
                        break;
                    default:
                        if(max<(ccBuffer-1) && IsValidChar(InRec[i].Event.KeyEvent.uChar.UnicodeChar))
                        {
                            StrCopyNW(pBuf,ccBuffer,&pBuffer[iBuff],-1);
                            pBuffer[iBuff]=InRec[i].Event.KeyEvent.uChar.UnicodeChar;
                            pBuffer[iBuff+1]=0;
                            max=StrCatW(&pBuffer[0],ccBuffer,(pwsz[0]=&pBuffer[0],pwsz[1]=pBuf,pwsz[2]=0,(WCHAR**)&pwsz));
                            WriteConsoleW(hOut,&pBuffer[iBuff],max-iBuff,0,0);
                            iBuff++;

                            tmp=csbi.dwCursorPosition;
                            GetConsoleScreenBufferInfo(hOut,&csbi);
                            end=csbi.dwCursorPosition;
                            csbi.dwCursorPosition=tmp;
                            if(csbi.dwCursorPosition.X >= csbi.dwSize.X-1)
                            {
                                csbi.dwCursorPosition.X=0;
                                csbi.dwCursorPosition.Y++;
                            }
                            else{csbi.dwCursorPosition.X++;}
                        }else{continue;}
                    }
                    SetConsoleCursorPosition(hOut,csbi.dwCursorPosition);
                }
            }
        }
        FlushConsoleInputBuffer(hIn);
    }
_ret_:
    WriteConsoleW(hOut,L"\n",1,0,0);
    FlushConsoleInputBuffer(hIn);
    GlobalFree(pBuf);
    CloseHandle(handles[0]);
	return max;
}

bool IsValidChar(WCHAR chr)
{
    WCHAR ValidChr[]=L" \t.,:;!-_#\'\"+-*/\\?}{()[]&%$<>|^~`=@";

    if(IsCharAlphaNumericW(chr))
        return TRUE;

    for(int i=0;ValidChr[i]!=0;i++)
    {
        if(ValidChr[i] == chr)
            return(TRUE);
    }
    return(FALSE);
}

int StrCopyNW(WCHAR* lpBuffer,int ccBuffer,WCHAR* lpSrc,int nChar)
{
    int i=0;
    ccBuffer--;
    for(;lpSrc[i]!=0 && ccBuffer!=0 && nChar!=0;i++,ccBuffer--,nChar--)
    {
        lpBuffer[i]=lpSrc[i];
    }
    lpBuffer[i]=0;
    return i;
}

int StrCatW(WCHAR* lpBuffer,int ccBuffer,WCHAR** papwsz)
{
    int ib=0,cnt=0;
    ccBuffer--;
    for(int ia=0;papwsz[ia]!=0 && ccBuffer!=0;ia++)
    {
        for(int i=0;(papwsz[ia])[i]!=0 && ccBuffer!=0;ib++,i++)
        {
            lpBuffer[ib]=(papwsz[ia])[i];
            cnt++;
            ccBuffer--;
        }
    }
    lpBuffer[ib]=0;
    return cnt;
}

int wszlen(WCHAR* pwsz)
{
	int i;
	for(i=0;pwsz[i]!=0;i++);
	return i;
}

WCHAR* dw2BaseXW(unsigned int num, int base ,WCHAR* pszBuffer)
{
	static WCHAR digit[]=L"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	WCHAR* psz=pszBuffer+32;
	int mod;

	if(base<2 || base > 36)
		return(pszBuffer[0]='-',pszBuffer[1]=0,pszBuffer);

	psz[0]=0;
	*psz--;

	while(true)
	{	
		mod = num%base;
		num = num/base;
		psz[0] = digit[mod];
		if(!num)
			break;
		*psz--;
	}
	return (psz);
}
